## indi 2.1.6+dfsg

=== indiserver/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(indiserver CXX)

if(WIN32 OR ANDROID)
    message(WARNING "INDI Server is only supported under Linux, BSD, MacOS, and Cygwin while current system is " ${CMAKE_SYSTEM_NAME})
else()
    find_package(Threads REQUIRED)
    find_package(Libev REQUIRED)

    add_executable(${PROJECT_NAME} indiserver.cpp
                                   LocalDvrInfo.cpp
                                   RemoteDvrInfo.cpp
                                   UnixServer.cpp
                                   TcpServer.cpp
                                   Fifo.cpp
                                   ClInfo.cpp
                                   DvrInfo.cpp
                                   MsgQueue.cpp
                                   SerializedMsg.cpp
                                   SerializedMsgWithoutSharedBuffer.cpp
                                   SerializedMsgWithSharedBuffer.cpp
                                   SerializationRequirement.cpp
                                   MsgChunck.cpp
                                   Msg.cpp
                                   Utils.cpp)

    target_link_libraries(indiserver indicore ${CMAKE_THREAD_LIBS_INIT} ${LIBEV_LIBRARIES})
    target_include_directories(indiserver SYSTEM PRIVATE ${LIBEV_INCLUDE_DIRS})

    install(TARGETS indiserver RUNTIME DESTINATION bin)
endif(WIN32 OR ANDROID)

=== integs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

FIND_PACKAGE (GTest REQUIRED)

INCLUDE_DIRECTORIES ( ${GTEST_INCLUDE_DIRS} )

include(GoogleTest)


MESSAGE (STATUS "INTEG:GTEST_INCLUDE_DIRS ${GTEST_INCLUDE_DIRS}")
MESSAGE (STATUS "INTEG:GTEST_LIBRARIES ${GTEST_LIBRARIES}")


# Workaround for fixing a linking error caused by "-pie" flag in CMakeCommon
STRING(REPLACE "-pie" "" CMAKE_EXE_LINKER_FLAGS ${CMAKE_EXE_LINKER_FLAGS})

add_executable(fakedriver fakedriver.cpp utils.cpp)

add_executable(XmlAwaiterTest XmlAwaiterTest.cpp XmlAwaiter.cpp)
target_link_libraries(XmlAwaiterTest ${GTEST_BOTH_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
gtest_discover_tests(XmlAwaiterTest PROPERTIES TIMEOUT 5)

set(TestCommonSources DriverMock.cpp ConnectionMock.cpp ProcessController.cpp IndiClientMock.cpp IndiServerController.cpp utils.cpp XmlAwaiter.cpp SharedBuffer.cpp ServerMock.cpp)

add_executable(TestIndiserverSingleDriver TestIndiserverSingleDriver.cpp ${TestCommonSources})
target_link_libraries(TestIndiserverSingleDriver ${GTEST_BOTH_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
gtest_discover_tests(TestIndiserverSingleDriver PROPERTIES TIMEOUT 5)

add_executable(TestClientQueries TestClientQueries.cpp ${TestCommonSources})
target_link_libraries(TestClientQueries ${GTEST_BOTH_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
gtest_discover_tests(TestClientQueries PROPERTIES TIMEOUT 5)

add_executable(TestIndiSetProp TestIndiSetProp.cpp ${TestCommonSources})
target_link_libraries(TestIndiSetProp ${GTEST_BOTH_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
gtest_discover_tests(TestIndiSetProp PROPERTIES TIMEOUT 10)

add_executable(TestIndiClient TestIndiClient.cpp ${TestCommonSources})
target_link_libraries(TestIndiClient indiclient ${GTEST_BOTH_LIBRARIES} ${ZLIB_LIBRARY} ${NOVA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
gtest_discover_tests(TestIndiClient PROPERTIES TIMEOUT 5)

# Inject properties for discovered tests
set_property(DIRECTORY APPEND PROPERTY
    TEST_INCLUDE_FILES ${CMAKE_CURRENT_LIST_DIR}/customTestProps.cmake
)

=== drivers/auxiliary/CMakeLists.txt ===
IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND INDI_INSTALL_UDEV_RULES)
    INSTALL(FILES 99-indi_auxiliary.rules DESTINATION ${UDEVRULES_INSTALL_DIR})
ENDIF()
# ########## Terrans PowerBoxGo V2 ###############
SET(terranspowerboxgov2_SRC
    Terrans_PowerBoxGo_V2.cpp)

add_executable(indi_terrans_powerboxgo_v2 ${terranspowerboxgov2_SRC})
target_link_libraries(indi_terrans_powerboxgo_v2 indidriver)
install(TARGETS indi_terrans_powerboxgo_v2 RUNTIME DESTINATION bin)

# ########## Terrans PowerBoxPro V2 ###############
SET(terranspowerboxprov2_SRC
    Terrans_PowerBoxPro_V2.cpp)

add_executable(indi_terrans_powerboxpro_v2 ${terranspowerboxprov2_SRC})
target_link_libraries(indi_terrans_powerboxpro_v2 indidriver)
install(TARGETS indi_terrans_powerboxpro_v2 RUNTIME DESTINATION bin)

# ########## WandererCover V4-EC###############
SET(indi_wanderercover_v4_ec_SRC
    wanderer_cover_v4_ec.cpp)

add_executable(indi_wanderercover_v4_ec ${indi_wanderercover_v4_ec_SRC})
target_link_libraries(indi_wanderercover_v4_ec indidriver)
install(TARGETS indi_wanderercover_v4_ec RUNTIME DESTINATION bin)

# ########## WandererCover V4 Pro-EC###############
SET(indi_wanderercover_v4_pro_ec_SRC
    wanderer_cover_v4_pro_ec.cpp)

add_executable(indi_wanderercover_v4_pro_ec ${indi_wanderercover_v4_pro_ec_SRC})
target_link_libraries(indi_wanderercover_v4_pro_ec indidriver)
install(TARGETS indi_wanderercover_v4_pro_ec RUNTIME DESTINATION bin)

# ########## Wanderer Eclipse###############
SET(indi_wanderer_eclipse_SRC
    wanderer_eclipse.cpp)

add_executable(indi_wanderer_eclipse ${indi_wanderer_eclipse_SRC})
target_link_libraries(indi_wanderer_eclipse indidriver)
install(TARGETS indi_wanderer_eclipse RUNTIME DESTINATION bin)

# ########## Astrolink-4###############
SET(indi_astrolink4_SRC
    indi_astrolink4.cpp)

add_executable(indi_astrolink4 ${indi_wanderercover_v4_ec_SRC})
target_link_libraries(indi_astrolink4 indidriver)
install(TARGETS indi_astrolink4 RUNTIME DESTINATION bin)

# ########## Wanderer Box Plus V3 ###############
SET(indi_wandererbox_plus_v3_SRC
    wandererbox_plus_v3.cpp)

add_executable(indi_wandererbox_plus_v3 ${indi_wandererbox_plus_v3_SRC})
target_link_libraries(indi_wandererbox_plus_v3 indidriver)
install(TARGETS indi_wandererbox_plus_v3 RUNTIME DESTINATION bin)

# ########## Wanderer Box Pro V3 ###############
SET(indi_wandererbox_pro_v3_SRC
    wandererbox_pro_v3.cpp)

add_executable(indi_wandererbox_pro_v3 ${indi_wandererbox_pro_v3_SRC})
target_link_libraries(indi_wandererbox_pro_v3 indidriver)
install(TARGETS indi_wandererbox_pro_v3 RUNTIME DESTINATION bin)

# ########## Wanderer Dew Terminator ###############
SET(indi_wanderer_dew_terminator_SRC
    wanderer_dew_terminator.cpp)

add_executable(indi_wanderer_dew_terminator ${indi_wanderer_dew_terminator_SRC})
target_link_libraries(indi_wanderer_dew_terminator indidriver)
install(TARGETS indi_wanderer_dew_terminator RUNTIME DESTINATION bin)

# ########## Wanderer Cover V3 ###############
SET(wandererCover_SRC
    wanderer_cover.cpp)

add_executable(indi_wanderer_cover ${wandererCover_SRC})
target_link_libraries(indi_wanderer_cover indidriver)
install(TARGETS indi_wanderer_cover RUNTIME DESTINATION bin)

# ########## SkySafari Middleware ##############
IF(INDI_BUILD_CLIENT)
    SET(skysafari_SRC
        skysafari.cpp
        skysafariclient.cpp)

    IF(UNITY_BUILD)
        ENABLE_UNITY_BUILD(skysafari skysafari_SRC 10 cpp)
    ENDIF()

    add_executable(indi_skysafari ${skysafari_SRC})
    target_link_libraries(indi_skysafari indidriver indiclient)
    install(TARGETS indi_skysafari RUNTIME DESTINATION bin)
ELSE()
    MESSAGE(WARNING "Skipping build of INDI SkySafari driver since INDI POSIX Client is not built")
ENDIF()

# ########## Watch dog ###############
if(INDI_BUILD_CLIENT)
    SET(watchdog_SRC
        watchdog.cpp
        watchdogclient.cpp)

    IF(UNITY_BUILD)
        ENABLE_UNITY_BUILD(watchdog watchdog_SRC 10 cpp)
    ENDIF()

    add_executable(indi_watchdog ${watchdog_SRC})

    target_link_libraries(indi_watchdog indidriver indiclient)
    install(TARGETS indi_watchdog RUNTIME DESTINATION bin)
ELSE()
    MESSAGE(WARNING "Skipping build of INDI WatchDog driver since INDI POSIX Client is not built")
ENDIF()

# ########## Flip Flat & Flip Man Driver ###############
SET(flipflat_SRC
    flip_flat.cpp)

add_executable(indi_flipflat ${flipflat_SRC})
target_link_libraries(indi_flipflat indidriver)
install(TARGETS indi_flipflat RUNTIME DESTINATION bin)

# ########## Light Panel Simulator ###############
SET(lightpanelsimulator_SRC
    light_panel_simulator.cpp)

add_executable(indi_simulator_lightpanel ${lightpanelsimulator_SRC})
target_link_libraries(indi_simulator_lightpanel indidriver)
install(TARGETS indi_simulator_lightpanel RUNTIME DESTINATION bin)

# ########## Dust Cover Simulator ###############
SET(dustcoversimulator_SRC
    dust_cover_simulator.cpp)

add_executable(indi_simulator_dustcover ${dustcoversimulator_SRC})
target_link_libraries(indi_simulator_dustcover indidriver)
install(TARGETS indi_simulator_dustcover RUNTIME DESTINATION bin)

# ########## Pegasus Ultimate Power Box Driver ###############
SET(pegasus_upb_SRC
    pegasus_upb.cpp)

add_executable(indi_pegasus_upb ${pegasus_upb_SRC})
target_link_libraries(indi_pegasus_upb indidriver)
install(TARGETS indi_pegasus_upb RUNTIME DESTINATION bin)

# ########## Pegasus USB Control Hub  ###############
SET(pegasus_uch_SRC
    pegasus_uch.cpp)

add_executable(indi_pegasus_uch ${pegasus_uch_SRC})
target_link_libraries(indi_pegasus_uch indidriver)
install(TARGETS indi_pegasus_uch RUNTIME DESTINATION bin)

# ########## Pegasus FlatMaster ###############
SET(pegasus_fm_SRC
    pegasus_flatmaster.cpp)

add_executable(indi_pegasus_flatmaster ${pegasus_fm_SRC})
target_link_libraries(indi_pegasus_flatmaster indidriver)
install(TARGETS indi_pegasus_flatmaster RUNTIME DESTINATION bin)

# ########## Pegasus Pocket Power Box Driver ###############
SET(pegasus_ppb_SRC
    pegasus_ppb.cpp)

add_executable(indi_pegasus_ppb ${pegasus_ppb_SRC})
target_link_libraries(indi_pegasus_ppb indidriver)
install(TARGETS indi_pegasus_ppb RUNTIME DESTINATION bin)

# ########## Pegasus Pocket Power Box Advance Driver ###############
SET(pegasus_ppba_SRC
    pegasus_ppba.cpp)

add_executable(indi_pegasus_ppba ${pegasus_ppba_SRC})
target_link_libraries(indi_pegasus_ppba indidriver)
install(TARGETS indi_pegasus_ppba RUNTIME DESTINATION bin)


# ########## Pegasus Saddle Power Box  Driver ###############
SET(pegasus_spb_SRC
    pegasus_spb.cpp)

add_executable(indi_pegasus_spb ${pegasus_spb_SRC})
target_link_libraries(indi_pegasus_spb indidriver)
install(TARGETS indi_pegasus_spb RUNTIME DESTINATION bin)

# ########## RB Focus Excalibur ###############
SET(Excalibur_SRC
    Excalibur.cpp)

add_executable(indi_Excalibur ${Excalibur_SRC})
target_link_libraries(indi_Excalibur indidriver)
install(TARGETS indi_Excalibur RUNTIME DESTINATION bin)

# ########## SnapCap Driver ###############
SET(snapcap_SRC
    snapcap.cpp)

add_executable(indi_snapcap ${snapcap_SRC})
target_link_libraries(indi_snapcap indidriver)
install(TARGETS indi_snapcap RUNTIME DESTINATION bin)

# ########## Light Pollution Meter #############
SET(lpm_SRC
    lpm.cpp)

add_executable(indi_astromech_lpm ${lpm_SRC})
target_link_libraries(indi_astromech_lpm indidriver)
install(TARGETS indi_astromech_lpm RUNTIME DESTINATION bin)


# ########## Astrolink Mini v2 #############
SET(astrolinkminiv2_SRC
    indi_astrolink4mini2.cpp)

add_executable(indi_astrolink4mini2 ${astrolinkminiv2_SRC})
target_link_libraries(indi_astrolink4mini2 indidriver)
install(TARGETS indi_astrolink4mini2 RUNTIME DESTINATION bin)


# ########## Sky Quality Meter ###############
SET(sqm_SRC
    sqm.cpp)

add_executable(indi_sqm_weather ${sqm_SRC})
target_link_libraries(indi_sqm_weather indidriver)
install(TARGETS indi_sqm_weather RUNTIME DESTINATION bin)

# ########## Sky Quality Meter Simulator ###############
SET(sqm_simulator_SRC
    sqm_simulator.cpp)

add_executable(indi_simulator_sqm ${sqm_simulator_SRC})
target_link_libraries(indi_simulator_sqm indidriver)
install(TARGETS indi_simulator_sqm RUNTIME DESTINATION bin)

# ########## Astrometry Driver ###############
SET(astrometry_SRC
    astrometrydriver.cpp)

add_executable(indi_astrometry ${astrometry_SRC})
target_link_libraries(indi_astrometry indidriver)
install(TARGETS indi_astrometry RUNTIME DESTINATION bin)

# ########## STAR2000 Driver ###############
SET(STAR2000_SRC
    STAR2kdriver.c
    STAR2000.cpp)

add_executable(indi_star2000 ${STAR2000_SRC})
target_link_libraries(indi_star2000 indidriver)
install(TARGETS indi_star2000 RUNTIME DESTINATION bin)

# ########## Arduino ST4 Driver ###############
SET(arduinost4_SRC arduino_st4.cpp)

IF(UNITY_BUILD)
    ENABLE_UNITY_BUILD(arduinost4 arduinost4_SRC 10 cpp)
ENDIF()

add_executable(indi_arduinost4 ${arduinost4_SRC})
target_link_libraries(indi_arduinost4 indidriver)
install(TARGETS indi_arduinost4 RUNTIME DESTINATION bin)

# ########## PlaneWave Delta-T Driver ###############
SET(planewave_deltat_SRC planewave_delta.cpp)

IF(UNITY_BUILD)
    ENABLE_UNITY_BUILD(indi_planewave_deltat planewave_deltat_SRC 10 cpp)
ENDIF()

add_executable(indi_planewave_deltat ${planewave_deltat_SRC})
target_link_libraries(indi_planewave_deltat indidriver)
install(TARGETS indi_planewave_deltat RUNTIME DESTINATION bin)

# ########## GPUSB Driver ###############
SET(gpusb_SRC
    gpdriver.cpp
    gpusb.cpp)

IF(UNITY_BUILD)
    ENABLE_UNITY_BUILD(gpusb gpusb_SRC 10 cpp)
ENDIF()

add_executable(indi_gpusb ${gpusb_SRC})
target_link_libraries(indi_gpusb indidriver)
install(TARGETS indi_gpusb RUNTIME DESTINATION bin)

# ########## Joystick Driver ###############
IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
    SET(joystick_SRC
        joystickdriver.cpp
        joystick.cpp)

    IF(UNITY_BUILD)
        ENABLE_UNITY_BUILD(joystick joystick_SRC 10 cpp)
    ENDIF()

    add_executable(indi_joystick ${joystick_SRC})
    target_link_libraries(indi_joystick indidriver)
    install(TARGETS indi_joystick RUNTIME DESTINATION bin)
ENDIF()

# ########## GPS Simulator Driver ###############
SET(gpssimulator_SRC
    gps_simulator.cpp)

add_executable(indi_simulator_gps ${gpssimulator_SRC})
target_link_libraries(indi_simulator_gps indidriver)
install(TARGETS indi_simulator_gps RUNTIME DESTINATION bin)

# ########## USB_Dewpoint Driver ###############
SET(usb_dewpoint_SRC
    usb_dewpoint.cpp)

add_executable(indi_usbdewpoint ${usb_dewpoint_SRC})
target_link_libraries(indi_usbdewpoint indidriver)
install(TARGETS indi_usbdewpoint RUNTIME DESTINATION bin)

# ########## myDewController Pro Driver ###############
SET(myDewControllerPro_SRC
    myDewControllerPro.cpp)

add_executable(indi_myDewControllerPro ${myDewControllerPro_SRC})
target_link_libraries(indi_myDewControllerPro indidriver)
install(TARGETS indi_myDewControllerPro RUNTIME DESTINATION bin)

# ########## CheapoDC Driver ###############
SET(cheapodc_SRC
    cheapodc.cpp)

add_executable(indi_cheapodc ${cheapodc_SRC})
target_link_libraries(indi_cheapodc indidriver)
install(TARGETS indi_cheapodc RUNTIME DESTINATION bin)

# ########## MYDCP4ESP32 Driver ###############
SET(mydcp4esp32_SRC
    mydcp4esp32.cpp)

add_executable(indi_mydcp4esp32 ${mydcp4esp32_SRC})
target_link_libraries(indi_mydcp4esp32 indidriver)
install(TARGETS indi_mydcp4esp32 RUNTIME DESTINATION bin)

# ########## Deep Sky Dad FP ###############
SET(deepskydad_fp_SRC
    deepskydad_fp.cpp)

add_executable(indi_deepskydad_fp ${deepskydad_fp_SRC})
target_link_libraries(indi_deepskydad_fp indidriver)
install(TARGETS indi_deepskydad_fp RUNTIME DESTINATION bin)

# ########## GIOTTO ###############
SET(giotto_SRC
    giotto.cpp
    ../focuser/primalucacommandset.cpp
)

add_executable(indi_giotto ${giotto_SRC})
target_link_libraries(indi_giotto indidriver)
install(TARGETS indi_giotto RUNTIME DESTINATION bin)

# ########## ALTO ###############
SET(alto_SRC
    alto.cpp

=== drivers/dome/CMakeLists.txt ===
# ############### Dome Simulator ################
SET(domesimulator_SRC
    dome_simulator.cpp)

add_executable(indi_simulator_dome ${domesimulator_SRC})
target_link_libraries(indi_simulator_dome indidriver)
install(TARGETS indi_simulator_dome RUNTIME DESTINATION bin)

# ############### Roll Off ################
SET(rolloff_SRC
    roll_off.cpp)

add_executable(indi_rolloff_dome ${rolloff_SRC})
target_link_libraries(indi_rolloff_dome indidriver)
install(TARGETS indi_rolloff_dome RUNTIME DESTINATION bin)

# ############### Baader Dome ################
SET(baaderdome_SRC
    baader_dome.cpp)

add_executable(indi_baader_dome ${baaderdome_SRC})
target_link_libraries(indi_baader_dome indidriver)
install(TARGETS indi_baader_dome RUNTIME DESTINATION bin)

# ############### Dome Pro 2 ##$##############
SET(domepro2_SRC
    domepro2.cpp)

add_executable(indi_domepro2_dome ${domepro2_SRC})
target_link_libraries(indi_domepro2_dome indidriver)
install(TARGETS indi_domepro2_dome RUNTIME DESTINATION bin)

# ############### Rigel Dome ################
SET(rigeldome_SRC
    rigel_dome.cpp)

add_executable(indi_rigel_dome ${rigeldome_SRC})
target_link_libraries(indi_rigel_dome indidriver)
install(TARGETS indi_rigel_dome RUNTIME DESTINATION bin)

# ############### ScopeDome Dome ################
set(scopedome_SRCS
    scopedome_dome.cpp
    scopedome_usb21.cpp
    scopedome_arduino.cpp
    scopedome_sim.cpp
)

add_executable(indi_scopedome_dome ${scopedome_SRCS})
target_link_libraries(indi_scopedome_dome indidriver ${CURL})
install(TARGETS indi_scopedome_dome RUNTIME DESTINATION bin)

# ############### Technical Innovations DDW Dome ################
set(ddw_dome_SRCS
    ddw_dome.cpp
)

add_executable(indi_ddw_dome ${ddw_dome_SRCS})
target_link_libraries(indi_ddw_dome indidriver)
install(TARGETS indi_ddw_dome RUNTIME DESTINATION bin)

# ########## Dome Scripting Gateway ##############
SET(domescript_SRC
    dome_script.cpp)

add_executable(indi_script_dome ${domescript_SRC})
target_link_libraries(indi_script_dome indidriver)
install(TARGETS indi_script_dome RUNTIME DESTINATION bin)

# ########## NexDome Beaver Controller ##############
SET(nexdome_beaver_SRC
    nexdome_beaver.cpp)

add_executable(indi_nexdome_beaver ${nexdome_beaver_SRC})
target_link_libraries(indi_nexdome_beaver indidriver)
install(TARGETS indi_nexdome_beaver RUNTIME DESTINATION bin)

# ############### DragonLAIR ################
SET(dragonlair_SRC
    dragonlair.cpp)

add_executable(indi_dragonlair_dome ${dragonlair_SRC})
target_link_libraries(indi_dragonlair_dome indidriver ${HTTPLIB_LIBRARY})
install(TARGETS indi_dragonlair_dome RUNTIME DESTINATION bin)

# ############### Universal ROR ################
SET(universalror_SRC
    universal_ror.cpp
    universal_ror_client.cpp
    )

add_executable(indi_universalror_dome ${universalror_SRC})
target_link_libraries(indi_universalror_dome indidriver indiclient)
install(TARGETS indi_universalror_dome RUNTIME DESTINATION bin)

# ############### Alpaca Dome ################
SET(alpaca_dome_SRC
    alpaca_dome.cpp
    )

add_executable(indi_alpaca_dome ${alpaca_dome_SRC})
target_link_libraries(indi_alpaca_dome indidriver indiclient ${HTTPLIB_LIBRARY})
install(TARGETS indi_alpaca_dome RUNTIME DESTINATION bin)

=== drivers/io/CMakeLists.txt ===
# ########## Waveshare Relay ###############
SET(wavesharerelay_SRC
    waveshare_modbus_relay.cpp
    ../../libs/modbus/nanomodbus.c
    )

add_executable(indi_wavesharemodbus_relay ${wavesharerelay_SRC})
target_link_libraries(indi_wavesharemodbus_relay indidriver)
install(TARGETS indi_wavesharemodbus_relay RUNTIME DESTINATION bin)

# ########## IPX800 Controller ###############
SET(ipx800v4_SRC
    ipx800v4.cpp)

add_executable(indi_ipx800v4 ${ipx800v4_SRC})
target_link_libraries(indi_ipx800v4 indidriver ${HTTPLIB_LIBRARY})
install(TARGETS indi_ipx800v4 RUNTIME DESTINATION bin)

# ########## Simulator IO ###############
SET(simulator_io_SRC
    simulator_io.cpp)

add_executable(indi_simulator_io ${simulator_io_SRC})
target_link_libraries(indi_simulator_io indidriver)
install(TARGETS indi_simulator_io RUNTIME DESTINATION bin)

=== drivers/rotator/CMakeLists.txt ===
# ############### Rigelsys nFrame Rotator ################
SET(nframe_SRC
    nframe.cpp)

add_executable(indi_nframe_rotator ${nframe_SRC})
target_link_libraries(indi_nframe_rotator indidriver)
install(TARGETS indi_nframe_rotator RUNTIME DESTINATION bin)

# ############### Rotator Simulator ########
SET(rotatorsim_SRC
    rotator_simulator.cpp)

IF(UNITY_BUILD)
    ENABLE_UNITY_BUILD(rotatorsim rotatorsim_SRC 10 cpp)
ENDIF()

add_executable(indi_simulator_rotator ${rotatorsim_SRC})
target_link_libraries(indi_simulator_rotator indidriver)
install(TARGETS indi_simulator_rotator RUNTIME DESTINATION bin)

# ############### Optec Gemini Focusing Rotator ########
SET(gemini_SRC
    gemini.cpp)

IF(UNITY_BUILD)
    ENABLE_UNITY_BUILD(gemini gemini_SRC 10 cpp)
ENDIF()

add_executable(indi_gemini_focus ${gemini_SRC})
target_link_libraries(indi_gemini_focus indidriver)
install(TARGETS indi_gemini_focus RUNTIME DESTINATION bin)

# ############### NightCrawler Focusing Rotator ################
SET(nightcrawler_SRC
    nightcrawler.cpp)

add_executable(indi_nightcrawler_focus ${nightcrawler_SRC})
target_link_libraries(indi_nightcrawler_focus indidriver)
install(TARGETS indi_nightcrawler_focus RUNTIME DESTINATION bin)

# ############### Pyxis Rotator ################
SET(pyxis_SRC
    pyxis.cpp)

add_executable(indi_pyxis_rotator ${pyxis_SRC})
target_link_libraries(indi_pyxis_rotator indidriver)
install(TARGETS indi_pyxis_rotator RUNTIME DESTINATION bin)

# ############### Falcon Rotator ################
SET(falcon_SRC
    pegasus_falcon.cpp)

add_executable(indi_falcon_rotator ${falcon_SRC})
target_link_libraries(indi_falcon_rotator indidriver)
install(TARGETS indi_falcon_rotator RUNTIME DESTINATION bin)

# ############### Camelot Rotator ################
SET(camelot_SRC
    camelot.cpp)

add_executable(indi_camelot_rotator ${camelot_SRC})
target_link_libraries(indi_camelot_rotator indidriver)
install(TARGETS indi_camelot_rotator RUNTIME DESTINATION bin)

# ############### Falcon V2 Rotator ################
SET(falconv2_SRC
    pegasus_falconv2.cpp)

add_executable(indi_falconv2_rotator ${falconv2_SRC})
target_link_libraries(indi_falconv2_rotator indidriver)
install(TARGETS indi_falconv2_rotator RUNTIME DESTINATION bin)

# ############### Wanderer Rotator Lite ################
SET(WandererRotatorLite_SRC
    wanderer_rotator_base.cpp
    wanderer_rotator_lite.cpp)

add_executable(indi_wanderer_lite_rotator ${WandererRotatorLite_SRC})
target_link_libraries(indi_wanderer_lite_rotator indidriver)
install(TARGETS indi_wanderer_lite_rotator RUNTIME DESTINATION bin)

# ############### Wanderer Rotator Mini ################
SET(WandererRotatorMini_SRC
    wanderer_rotator_base.cpp
    wanderer_rotator_mini.cpp)

add_executable(indi_wanderer_rotator_mini ${WandererRotatorMini_SRC})
target_link_libraries(indi_wanderer_rotator_mini indidriver)
install(TARGETS indi_wanderer_rotator_mini RUNTIME DESTINATION bin)

# ############### Wanderer Rotator Lite V2 ################
SET(WandererRotatorLiteV2_SRC
    wanderer_rotator_base.cpp
    wanderer_rotator_lite_v2.cpp)

add_executable(indi_wanderer_rotator_lite_v2 ${WandererRotatorLiteV2_SRC})
target_link_libraries(indi_wanderer_rotator_lite_v2 indidriver)
install(TARGETS indi_wanderer_rotator_lite_v2 RUNTIME DESTINATION bin)


# ############### Integra85 Focusing Rotator ################
SET(integra_SRC
    integra.cpp)

add_executable(indi_integra_focus ${integra_SRC})
target_link_libraries(indi_integra_focus indidriver)
install(TARGETS indi_integra_focus RUNTIME DESTINATION bin)

# ########## Deep Sky Dad FR1 ###############
SET(deepskydad_fr1_SRC
    deepskydad_fr1.cpp)

add_executable(indi_deepskydad_fr1 ${deepskydad_fr1_SRC})
target_link_libraries(indi_deepskydad_fr1 indidriver)
install(TARGETS indi_deepskydad_fr1 RUNTIME DESTINATION bin)

=== drivers/skeleton/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
PROJECT(libindi-skeletons C CXX)

include_directories(../../)
include_directories(../../libs)
include_directories(../../libs/indibase)

# ############### Sample Focuser Driver ################
SET(focuserdriver_SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/focuser_driver.cpp)

add_executable(indi_focuser_driver_focus ${focuserdriver_SRC})
target_link_libraries(indi_focuser_driver_focus indidriver)
install(TARGETS indi_focuser_driver_focus RUNTIME DESTINATION bin)

# ############### Sample Mount Driver ################
SET(mountdriver_SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/mount_driver.cpp)

add_executable(indi_mount_driver_telescope ${mountdriver_SRC})
target_link_libraries(indi_mount_driver_telescope indidriver)
install(TARGETS indi_mount_driver_telescope RUNTIME DESTINATION bin)

=== drivers/telescope/CMakeLists.txt ===
# ###################################################################################################
#
# Component   : LX200 Library
# Dependencies: pthreads
# Supported OS: Linux, BSD, MacOS, Cygwin
#
# ################################################################################################

add_library(indilx200 SHARED
    lx200driver.cpp
    lx200telescope.cpp)

if(NOT WIN32)
    set_target_properties(indilx200 PROPERTIES COMPILE_FLAGS "-fPIC")
endif(NOT WIN32)

target_compile_definitions(indilx200 PRIVATE _XOPEN_SOURCE=700 HAVE_LIBNOVA)
set_target_properties(indilx200 PROPERTIES VERSION ${CMAKE_INDI_VERSION_STRING} SOVERSION ${INDI_SOVERSION} OUTPUT_NAME indilx200)

target_link_libraries(indilx200 indidevice $<$<PLATFORM_ID:CYGWIN>:indidriver>)

install(TARGETS indilx200 LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES
    lx200telescope.h
    lx200driver.h
    DESTINATION ${INCLUDE_INSTALL_DIR}/libindi/mounts
    COMPONENT Devel)

# ################################################################################

# ########## LX200 Basic #############
add_executable(indi_lx200basic
    lx200driver.cpp
    lx200basic.cpp)

target_link_libraries(indi_lx200basic indidriver)

install(TARGETS indi_lx200basic RUNTIME DESTINATION bin)

# ################################################################################

# ########## LX200 TeenAstro #############
add_executable(indi_lx200_TeenAstro
    lx200driver.cpp
    lx200_TeenAstro.cpp)

target_compile_definitions(indi_lx200_TeenAstro PRIVATE _XOPEN_SOURCE=700)
target_link_libraries(indi_lx200_TeenAstro indidriver)

install(TARGETS indi_lx200_TeenAstro RUNTIME DESTINATION bin)

# ################################################################################

# ########## LX200 Generic ###########
add_executable(indi_lx200generic
    lx200driver.cpp
    lx200autostar.cpp
    lx200_16.cpp
    lx200gps.cpp
    lx200generic.cpp
    lx200telescope.cpp
    lx200classic.cpp
    lx200gemini.cpp
    lx200zeq25.cpp
    lx200am5.cpp
    lx200gotonova.cpp
    lx200pulsar2.cpp
    lx200apdriver.cpp
    lx200ap_v2.cpp
    lx200ap_gtocp2.cpp
    lx200fs2.cpp
    lx200ss2000pc.cpp
    lx200_OnStep.cpp
    lx200_OpenAstroTech.cpp
    lx200_pegasus_nyx101.cpp
    lx200_10micron.cpp
    ioptronHC8406.cpp
    eq500x.cpp)

if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    target_compile_definitions(indi_lx200generic PRIVATE -D_XOPEN_SOURCE=700)
ELSE()
    target_compile_definitions(indi_lx200generic PRIVATE -D_XOPEN_SOURCE=600 -D_POSIX_C_SOURCE=200809L)
ENDIF()

target_link_libraries(indi_lx200generic indidriver)

install(TARGETS indi_lx200generic RUNTIME DESTINATION bin)

file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/make_lx200generic_symlink.cmake
    "exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200classic)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200autostar)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200_16)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200gps)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200ap_v2)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200ap_legacy)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200gemini)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200zeq25)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200am5)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200gotonova)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200pulsar2)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200fs2)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200ss2000pc)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200_OnStep)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200_OpenAstroTech)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200_pegasus_nyx101)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_lx200_10micron)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_ioptronHC8406)\n
exec_program(\"${CMAKE_COMMAND}\" ARGS -E create_symlink indi_lx200generic \$ENV{DESTDIR}${BIN_INSTALL_DIR}/indi_eq500x_telescope)\n
")
set_target_properties(indi_lx200generic PROPERTIES POST_INSTALL_SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/make_lx200generic_symlink.cmake)

# ################################################################################

# ########## Celestron GPS ############
add_executable(indi_celestron_gps
    celestrondriver.cpp
    celestrongps.cpp)

target_link_libraries(indi_celestron_gps indidriver)

install(TARGETS indi_celestron_gps RUNTIME DESTINATION bin)

# ########## Rainbow Mount driver ##########
add_executable(indi_rainbow_telescope
    rainbow.cpp
    lx200driver.cpp)

target_compile_definitions(indi_rainbow_telescope PRIVATE _XOPEN_SOURCE=700)

target_link_libraries(indi_rainbow_telescope indidriver)

install(TARGETS indi_rainbow_telescope RUNTIME DESTINATION bin)

# ########## HOBYM / TitanTCS for CRUX Mount ##########
add_executable(indi_crux_mount
    crux_mount.cpp)

target_link_libraries(indi_crux_mount indidriver)

install(TARGETS indi_crux_mount RUNTIME DESTINATION bin)

# ########## Takahashi Temma ##########
add_executable(indi_temma_telescope
    temmadriver.cpp)

target_link_libraries(indi_temma_telescope indidriver AlignmentDriver)

install(TARGETS indi_temma_telescope RUNTIME DESTINATION bin)

# ########## Paramount ##########
add_executable(indi_paramount_telescope
    paramount.cpp)

target_link_libraries(indi_paramount_telescope indidriver)

install(TARGETS indi_paramount_telescope RUNTIME DESTINATION bin)

# ########## Astrotrac ##########
add_executable(indi_astrotrac_telescope
    astrotrac.cpp)

target_link_libraries(indi_astrotrac_telescope AlignmentDriver indidriver)

install(TARGETS indi_astrotrac_telescope RUNTIME DESTINATION bin)

# ########## Syncscan ###############
add_executable(indi_synscan_telescope
    synscandriver.cpp
    synscanmount.cpp)

target_link_libraries(indi_synscan_telescope indidriver AlignmentDriver)

install(TARGETS indi_synscan_telescope RUNTIME DESTINATION bin)

# ########## Syncscan Legacy ###############
add_executable(indi_synscanlegacy_telescope
    synscandriverlegacy.cpp
    synscanmountlegacy.cpp)

target_link_libraries(indi_synscanlegacy_telescope indidriver AlignmentDriver)

install(TARGETS indi_synscanlegacy_telescope RUNTIME DESTINATION bin)

# ########## Sky Commander ###############
add_executable(indi_skycommander_telescope
    skycommander.cpp)

target_link_libraries(indi_skycommander_telescope indidriver)

install(TARGETS indi_skycommander_telescope RUNTIME DESTINATION bin)

# ########## Generic Digital Setting Circle ###############
add_executable(indi_dsc_telescope
    dsc.cpp)

target_link_libraries(indi_dsc_telescope AlignmentDriver indidriver)

install(TARGETS indi_dsc_telescope RUNTIME DESTINATION bin)

# ########## IEQ Pro Legacy #############
add_executable(indi_ieqlegacy_telescope
    ieqprolegacydriver.cpp
    ieqprolegacy.cpp)

target_link_libraries(indi_ieqlegacy_telescope indidriver)

install(TARGETS indi_ieqlegacy_telescope RUNTIME DESTINATION bin)

# ########## IEQ Pro #############
add_executable(indi_ieq_telescope
    ieqdriverbase.cpp
    ieqpro.cpp)

target_link_libraries(indi_ieq_telescope indidriver)

install(TARGETS indi_ieq_telescope RUNTIME DESTINATION bin)

# ########## IOptronV3 / CEM120 #############
add_executable(indi_ioptronv3_telescope
    ioptronv3driver.cpp
    ioptronv3.cpp)

target_link_libraries(indi_ioptronv3_telescope indidriver)

install(TARGETS indi_ioptronv3_telescope RUNTIME DESTINATION bin)

# ########## Explore Scientific PMC8 #############
add_executable(indi_pmc8_telescope
    pmc8driver.cpp
    pmc8.cpp)

target_link_libraries(indi_pmc8_telescope indidriver)

install(TARGETS indi_pmc8_telescope RUNTIME DESTINATION bin)

# ########## Telescope Simulator ##############
add_executable(indi_simulator_telescope
    telescope_simulator.cpp
    scopesim_helper.cpp)

target_link_libraries(indi_simulator_telescope indidriver)

install(TARGETS indi_simulator_telescope RUNTIME DESTINATION bin)

# ########## Telescope Scripting Gateway ##############
add_executable(indi_script_telescope
    telescope_script.cpp)

target_link_libraries(indi_script_telescope indidriver)

install(TARGETS indi_script_telescope RUNTIME DESTINATION bin)

# ########## Skywatcher Alt-Az Mount ##############
add_executable(indi_skywatcherAltAzMount
    skywatcherAPIMount.cpp
    skywatcherAPI.cpp)

target_link_libraries(indi_skywatcherAltAzMount AlignmentDriver indidriver)

install(TARGETS indi_skywatcherAltAzMount RUNTIME DESTINATION bin)

# ########## Planewave Mount ##############
add_executable(indi_planewave_telescope
    planewave_mount.cpp)

target_link_libraries(indi_planewave_telescope indidriver ${HTTPLIB_LIBRARY})

install(TARGETS indi_planewave_telescope RUNTIME DESTINATION bin)

=== examples/tutorial_two/CMakeLists.txt ===
########## Tutorial two ##############
add_executable(tutorial_two simplescope.cpp)

target_link_libraries(tutorial_two indidriver)

=== libs/alignment/CMakeLists.txt ===
set(INDI_MATH_PLUGINS_DIRECTORY "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/indi/MathPlugins")
set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS INDI_MATH_PLUGINS_DIRECTORY="${INDI_MATH_PLUGINS_DIRECTORY}")

option(ALIGNMENT_CONVEX_HULL_DEBUGGING "Alignment subsystem - additional debugging output" OFF)

if(ALIGNMENT_CONVEX_HULL_DEBUGGING)
    set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS CONVEX_HULL_DEBUGGING)
endif(ALIGNMENT_CONVEX_HULL_DEBUGGING)

# #################################################
# ###### INDI AlignmentDriver shared library ######
# #################################################
SET(AlignmentDriver_SRC
    AlignmentSubsystemForDrivers.cpp
    AlignmentSubsystemForMathPlugins.h
    BasicMathPlugin.cpp
    BuiltInMathPlugin.cpp
    ConvexHull.cpp
    DriverCommon.cpp
    InMemoryDatabase.cpp
    MapPropertiesToInMemoryDatabase.cpp
    MathPlugin.cpp
    MathPluginManagement.cpp
    TelescopeDirectionVectorSupportFunctions.cpp
    Common.cpp)

IF(UNITY_BUILD)
    ENABLE_UNITY_BUILD(AlignmentDriver AlignmentDriver_SRC 15 cpp)
ENDIF()

add_library(AlignmentDriver SHARED ${AlignmentDriver_SRC})
set_target_properties(AlignmentDriver PROPERTIES COMPILE_FLAGS "-fPIC")

IF(APPLE)
    target_link_libraries(AlignmentDriver ${CMAKE_DL_LIBS} -L/usr/local/lib ${GSL_LIBRARIES})
ELSE()
    # Force linking all referenced libraries because of libgsl is not linked against cblas library on Linux
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-as-needed")
    target_link_libraries(AlignmentDriver ${CMAKE_DL_LIBS} ${GSL_LIBRARIES}
        $<$<PLATFORM_ID:CYGWIN>:indidriver>
    )
ENDIF()

target_link_libraries(AlignmentDriver indidevice indiclient)

if(INDI_BUILD_QT5)
    target_link_libraries(AlignmentDriver Qt5::Network)
endif(INDI_BUILD_QT5)

set_target_properties(AlignmentDriver PROPERTIES VERSION ${CMAKE_INDI_VERSION_STRING} SOVERSION ${INDI_SOVERSION} OUTPUT_NAME indiAlignmentDriver)
install(TARGETS AlignmentDriver
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
    AlignmentSubsystemForMathPlugins.h
    AlignmentSubsystemForDrivers.h
    BasicMathPlugin.h
    BuiltInMathPlugin.h
    NearestMathPlugin.h
    ClientAPIForAlignmentDatabase.h
    ClientAPIForMathPluginManagement.h
    Common.h
    ConvexHull.h
    DriverCommon.h
    InMemoryDatabase.h
    MathPlugin.h
    MathPluginManagement.h
    SVDMathPlugin.h
    TelescopeDirectionVectorSupportFunctions.h
    MapPropertiesToInMemoryDatabase.h
    DESTINATION ${INCLUDE_INSTALL_DIR}/libindi/alignment COMPONENT Devel)

# #################################################
# ###### INDI AlignmentClient static library ######
# #################################################
set(AlignmentClient_SRCS
    AlignmentSubsystemForClients.cpp
    ClientAPIForAlignmentDatabase.cpp
    ClientAPIForMathPluginManagement.cpp
    Common.h
)

add_library(AlignmentClient STATIC ${AlignmentClient_SRCS})

if(INDI_BUILD_QT5)
    target_link_libraries(AlignmentClient Qt5::Network)
endif(INDI_BUILD_QT5)

if(NOT WIN32)
    SET_TARGET_PROPERTIES(AlignmentClient PROPERTIES COMPILE_FLAGS "-fPIC")
endif(NOT WIN32)

target_link_libraries(AlignmentClient indidevice indiclient)

set_target_properties(AlignmentClient PROPERTIES OUTPUT_NAME indiAlignmentClient)
install(TARGETS AlignmentClient ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

# #################################################
# ########### LoaderCLient test program ###########
# #################################################
# set(LoaderClient_SRCS
# LoaderClient.cpp
# LoaderMain.cpp
# )

# add_executable(LoaderClient ${LoaderClient_SRCS})

# target_link_libraries(LoaderClient indiclient AlignmentClient)

# install(TARGETS LoaderClient RUNTIME DESTINATION bin)

# #################################################
# ######## MathPluginManager test program #########
# #################################################
# set(MathPluginManagerClient_SRCS
# MathPluginManagerClient.cpp
# MathPluginManagerMain.cpp
# )

# add_executable(MathPluginManagerClient ${MathPluginManagerClient_SRCS})

# target_link_libraries(MathPluginManagerClient indiclient AlignmentClient)

# install(TARGETS MathPluginManagerClient RUNTIME DESTINATION bin)

# #################################################
# ########## Dummy math plugin example ############
# #################################################
# set(DummyMathPlugin_SRCS
# DummyMathPlugin.cpp
# )

# add_library(indi_Dummy_MathPlugin SHARED ${DummyMathPlugin_SRCS})

# target_link_libraries(indi_Dummy_MathPlugin indidriver)

# install(TARGETS indi_Dummy_MathPlugin LIBRARY DESTINATION ${INDI_MATH_PLUGINS_DIRECTORY})

# #################################################
# ############### Nearest math plugin #############
# #################################################
set(NearestMathPlugin_SRCS
    NearestMathPlugin.cpp
)

add_library(indi_Nearest_MathPlugin SHARED ${NearestMathPlugin_SRCS})
target_include_directories(indi_Nearest_MathPlugin
    PRIVATE
        ${libindi_SOURCE_DIR}/libs/indicore
)
target_link_libraries(indi_Nearest_MathPlugin
    indidriver
    $<$<PLATFORM_ID:CYGWIN>:AlignmentDriver>
)

install(TARGETS indi_Nearest_MathPlugin
    ARCHIVE DESTINATION ${INDI_MATH_PLUGINS_DIRECTORY}
    LIBRARY DESTINATION ${INDI_MATH_PLUGINS_DIRECTORY}
    RUNTIME DESTINATION ${INDI_MATH_PLUGINS_DIRECTORY})

# #################################################
# ############### SVD math plugin #################
# #################################################
set(SVDMathPlugin_SRCS
    SVDMathPlugin.cpp
)

add_library(indi_SVD_MathPlugin SHARED ${SVDMathPlugin_SRCS})
set_property(TARGET indi_SVD_MathPlugin APPEND PROPERTY COMPILE_DEFINITIONS SVD_TRANSFORM_MATRIX)
target_link_libraries(indi_SVD_MathPlugin
    indidriver
    $<$<PLATFORM_ID:CYGWIN>:AlignmentDriver>
)

install(TARGETS indi_SVD_MathPlugin
    ARCHIVE DESTINATION ${INDI_MATH_PLUGINS_DIRECTORY}
    LIBRARY DESTINATION ${INDI_MATH_PLUGINS_DIRECTORY}
    RUNTIME DESTINATION ${INDI_MATH_PLUGINS_DIRECTORY})

=== libs/fpack/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
project(fpack C)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.31)
    cmake_policy(SET CMP0177 NEW)
endif()

add_library(${PROJECT_NAME} OBJECT "")

# Headers
list(APPEND ${PROJECT_NAME}_HEADERS
)

list(APPEND ${PROJECT_NAME}_PRIVATE_HEADERS
)

# Sources
list(APPEND ${PROJECT_NAME}_SOURCES
    fpack.c
    fpackutil.c
)

# Setup Target
target_sources(${PROJECT_NAME}
    PUBLIC
    ${${PROJECT_NAME}_HEADERS}
    PRIVATE
    ${${PROJECT_NAME}_SOURCES}
    ${${PROJECT_NAME}_PRIVATE_HEADERS}
)

target_include_directories(${PROJECT_NAME}
    PUBLIC .
)

install(FILES
    ${${PROJECT_NAME}_HEADERS}
    DESTINATION
    ${INCLUDE_INSTALL_DIR}/libindi
    COMPONENT Devel
)

=== libs/hid/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
project(hid C)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.31)
    cmake_policy(SET CMP0177 NEW)
endif()

add_library(${PROJECT_NAME} OBJECT "")

# Headers
list(APPEND ${PROJECT_NAME}_HEADERS
    hidapi.h
)

list(APPEND ${PROJECT_NAME}_PRIVATE_HEADERS
)

# Sources
if(APPLE)
    list(APPEND ${PROJECT_NAME}_SOURCES hid_mac.c)
elseif(WIN32)
    list(APPEND ${PROJECT_NAME}_SOURCES hid_win.c)
else()
    list(APPEND ${PROJECT_NAME}_SOURCES hid_libusb.c)
endif()

# Setup Target
target_sources(${PROJECT_NAME}
    PUBLIC
    ${${PROJECT_NAME}_HEADERS}
    PRIVATE
    ${${PROJECT_NAME}_SOURCES}
    ${${PROJECT_NAME}_PRIVATE_HEADERS}
)

target_include_directories(${PROJECT_NAME}
    PUBLIC .
)

install(FILES
    ${${PROJECT_NAME}_HEADERS}
    DESTINATION
    ${INCLUDE_INSTALL_DIR}/libindi
    COMPONENT Devel
)

# ########## HID Test ##############
if(APPLE)
    set(LIBS "-framework IOKit -framework CoreFoundation")
elseif(CYGWIN OR UNIX)
    set(LIBS ${Iconv_LIBRARIES})
endif()

add_executable(indi_hid_test hidtest.cpp)
target_link_libraries(indi_hid_test hid ${USB1_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${LIBS})
install(TARGETS indi_hid_test RUNTIME DESTINATION bin)

=== debian/changelog ===
indi (2.1.6+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Update repacking list in debian/copyright:
    - remove '3rdparty' and 'macosx', as they have not been shipped for a long
      time
    - add files generated by cmake accidentally shipped in the tarball
  * Move the libindi-plugins dependency from libindialignmentdriver2 to
    indi-bin: this avoids a circular dependency, and the plugins are used by the
    INDI drivers.

 -- Pino Toscano <pino@debian.org>  Sun, 05 Oct 2025 23:28:30 +0200

=== debian/control ===
Source: indi
Section: misc
Priority: optional
Maintainer: Debian Krap Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: cmake (>= 3.18~),
               debhelper-compat (= 13),
               libcfitsio-dev,
               libcpp-httplib-dev,
               libcurl4-gnutls-dev,
               libev-dev,
               libfftw3-dev,
               libgsl-dev,
               libjpeg-dev,
               libnova-dev (>= 0.16),
               libogg-dev,
               libtheora-dev,
               libusb-1.0-0-dev,
               libxisf-dev (>= 0.2.9),
               nlohmann-json3-dev,
               pkgconf,
               pkg-kde-tools (>= 0.12),
               zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://www.indilib.org/
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/indi.git -b experimental
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/indi/-/tree/experimental

Package: libindidriver2
Section: libs
Architecture: any
Depends: libindi-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- driver library
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the driver shared library.

Package: libindialignmentdriver2
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- alignment driver lib
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the alignment driver shared library.

Package: libindilx200-2
Section: libs
Architecture: any
Depends: libindi-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- lx200 driver lib
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the lx200 driver shared library.

Package: libindiclient2
Section: libs
Architecture: any
Depends: libindi-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- client library
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the client shared library.

Package: libindi-plugins
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- plugins
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains binary plugins.

Package: libindi-dev
Section: libdevel
Architecture: any
Depends: libcfitsio-dev,
         libusb-1.0-0-dev,
         ${so:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: Instrument-Neutral Device Interface library -- development files
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains development headers and libraries for the INDI library.

Package: libindi-data
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Instrument-Neutral Device Interface library -- shared data
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the data files for the INDI library.

Package: indi-bin
Architecture: any
Depends: libindi-data (>= ${source:Version}),
         libindi-plugins (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: INDI server, drivers and tools
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the INDI server, the drivers for the supported
 astronomical instrumentation, and other INDI tools.

=== debian/rules ===
#!/usr/bin/make -f

libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/2/library-packages.mk

include /usr/share/dpkg/architecture.mk

archs_that_need_atomic = riscv64
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_that_need_atomic)))
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed
endif

%:
	dh $@ --with sodeps

override_dh_auto_configure:
	dh_auto_configure -- -DINDI_SYSTEM_HTTPLIB=ON -DINDI_SYSTEM_JSONLIB=ON -DINDI_BUILD_EXAMPLES=OFF

override_dh_gencontrol-arch: libpkgs_gen_strict_local_shlibs
	dh_gencontrol -a
